Geometry.CopyMeshingMethod=1;
lc=0.05;
L=15.;
Rext=2*L/3;
Rin=L/3;
P=20*L;
i=0;
sum=2;
List[]={Rin,-Rin,Rext,-Rext,L,-L};

Point(1)={0.,0.,0.,lc};
For i In {0:5:1}						//25 points créés
Point(sum)={List[i],List[i],0,lc};
Point(sum+1)={0,List[i],0,lc};
Point(sum+2)={-List[i],List[i],0,lc};
Point(sum+3)={-List[i],0,0,lc};
sum=sum+4;
EndFor
Point(26)={Sqrt(2)*Rext/2,Sqrt(2)*Rext/2,0.,lc};
Point(27)={-Sqrt(2)*Rext/2,Sqrt(2)*Rext/2,0.,lc};
Point(28)={-Sqrt(2)*Rext/2,-Sqrt(2)*Rext/2,0.,lc};
Point(29)={Sqrt(2)*Rext/2,-Sqrt(2)*Rext/2,0.,lc};

For i In {2:25:4}//24 lignes créées
Line(i)={i,i+1};
Line(i+1)={i+1,i+2};
Line(i+2)={i+2,i+3};
If ((i+3)==9 || (i+3)==17 ||(i+3)==25)
Line(i+3)={i+3,i-4};
EndIf
If ((i+3)!=9 && (i+3)!=17&&(i+3)!=25)
Line(i+3)={i+3,i+4};
EndIf
EndFor

For i In {2:25}
Transfinite Line {i}=5;
EndFor

sum=26;
For i In {3:17:2}
Line(sum)={i,i+8};
If (i<=9)
Transfinite Line{sum}=5;
EndIf
If (i>9)
Transfinite Line{sum}=3;
EndIf
sum=sum+1;
EndFor

Line(sum)={18,26};sum=sum+1;
Line(sum)={20,27};sum=sum+1;
Line(sum)={22,28};sum=sum+1;
Line(sum)={24,29};sum=sum+1;
Transfinite Line {34,35,36,37}=3;

For i In {3:9:2}
If (i<9)
Circle(sum)={i,1,i+2};
EndIf
If (i==9)
Circle(sum)={i,1,i-6};
EndIf
Transfinite Line(sum)=9;
sum=sum+1;
EndFor

Printf("%g",sum);
Circle(sum)={11,1,27};
Cext0[]=Rotate{{0,0,1},{0,0,0},Pi/4}{Duplicata{Line{sum};}};
Cext1[]=Rotate{{0,0,1},{0,0,0},Pi/2}{Duplicata{Line{sum,Cext0[0]};}};
Cext2[]=Rotate{{0,0,1},{0,0,0},Pi}{Duplicata{Line{sum,Cext0[0],Cext1[0],Cext1[1]};}};

For i In {1:8}
Transfinite Line{sum}=5;sum=sum+1;
EndFor 

//Centre Piezo
Line Loop(1)={38,39,40,41}; 
Plane Surface(1)={1}; 
Transfinite Surface{1}={3,5,7,9};
Recombine Surface(1);

//Anneau Intérieur
Line Loop(2)={38,27,-43,-42,-26};
Plane Surface (2)={2};
Transfinite Surface{2}={13,11,3,5}; Recombine Surface(2);
Sin0[]=Rotate{{0,0,1},{0,0,0},Pi/2}{Duplicata{Surface{2};}};
Transfinite Surface{Sin0[0]}={15,13,5,7}; Recombine Surface(Sin0[0]);
Sin1[]=Rotate{{0,0,1},{0,0,0},Pi}{Duplicata{Surface{2,Sin0[0]};}};
Transfinite Surface{Sin1[0]}={17,15,7,9}; Recombine Surface(Sin1[0]);
Transfinite Surface{Sin1[1]}={11,17,9,3}; Recombine Surface(Sin1[1]);

// Anneau Extérieur
Line Loop (3)={42,-35,-19,-30}; Plane Surface(3)={3};
Transfinite Surface{3}={27,11,19,20};Recombine Surface(3);
Line Loop (4)={43,31,-20,35}; Plane Surface(4)={4};
Transfinite Surface{4}={27,13,21,20};Recombine Surface(4);
Sext0[]=Rotate{{0,0,1},{0,0,0},Pi/2}{Duplicata{Surface{3,4};}};
Sext1[]=Rotate{{0,0,1},{0,0,0},Pi}{Duplicata{Surface{3,4,Sext0[0],Sext0[1]};}};

//Piezo[]=Extrude{0,0,1}{Surface{1,2,Sin0[0],Sin1[0],Sin1[1]};Layers {1};Recombine;};

//Physical definition
//Printf("Piezo[0] = %g",Piezo[0]);

//Physical Volume ("Piezo")={Piezo[0],Piezo[1],Piezo[7],Piezo[14],Piezo[21], Piezo[28]};
Physical Surface ("Body")= {1,2,3,4,50,51,57,58,63,64,69,74,79};
//Physical Surface ("Support")={Piezo[0]};



